Name:		qubes-utils
Version:	4.3.5
Release:	1%{?dist}
Summary:	Common Linux files for Qubes Dom0 and VM
Source0:    %{name}-%{version}.tar.gz

Group:		Qubes
License:	GPL
URL:		http://www.qubes-os.org

Requires:	udev
Requires:	%{name}-libs
Requires:	GraphicsMagick
Requires:	python%{python3_pkgversion}-qubesimgconverter
Requires:	(%{name}-selinux if selinux-policy)
%{?systemd_requires}
BuildRequires:  systemd
BuildRequires:  python%{python3_pkgversion}-setuptools
BuildRequires:  python3-rpm-macros
# for meminfo-writer
BuildRequires:  xen-devel
BuildRequires:	gcc
BuildRequires:  selinux-policy-devel
%if 0%{?is_opensuse}
# for directory ownership
BuildRequires: xen-tools
%endif

%description
Common Linux files for Qubes Dom0 and VM

%package -n python%{python3_pkgversion}-qubesimgconverter
Summary:    Python package qubesimgconverter
Requires:   python%{python3_pkgversion}
Requires:   python%{python3_pkgversion}-cairo
%if 0%{?is_opensuse}
Requires:   python%{python3_pkgversion}-Pillow
%else
Requires:   python%{python3_pkgversion}-pillow
%endif
Requires:   python%{python3_pkgversion}-numpy

%description -n python%{python3_pkgversion}-qubesimgconverter
Python package qubesimgconverter

%package devel
Summary:	Development headers for qubes-utils
Release:	1%{?dist}
Requires:	%{name}-libs

%description devel
Development header and files for qubes-utils

%package libs
Summary: Qubes utils libraries
Release:	1%{?dist}
BuildRequires:	pkgconfig(icu-uc)
BuildRequires:	python3

%description libs
Libraries for qubes-utils

%package selinux

BuildRequires: selinux-policy
%{?selinux_requires}

Summary: SELinux policy for meminfo-writer
License: GPLv2+

%description selinux
SELinux policy for meminfo-writer.  You need this package to run meminfo-writer
on a system where SELinux is in enforcing mode.

%post selinux
%selinux_modules_install %{_datadir}/selinux/packages/qubes-meminfo-writer.pp || :

%postun selinux
if [ "$1" -eq 0 ]; then
    %selinux_modules_uninstall %{_datadir}/selinux/packages/qubes-meminfo-writer.pp
fi || :

%posttrans selinux
%selinux_relabel_post
exit 0

%files selinux
%{_datadir}/selinux/packages/qubes-meminfo-writer.pp
%{_datadir}/selinux/devel/include/contrib/ipp-qubes-meminfo-writer.if

%prep
%setup -q

%build
make all selinux BACKEND_VMM=xen PYTHON=%{__python3} NO_REBUILD_TABLE=1

%check
make -C qrexec-lib check NO_REBUILD_TABLE=1
%if 0%{?fedora} == 38
make -C qrexec-lib check-table-up-to-date NO_REBUILD_TABLE=1
%endif

%install
make install install-selinux DESTDIR=%{buildroot} PYTHON=%{__python3} NO_REBUILD_TABLE=1

%post
# dom0
%systemd_post qubes-meminfo-writer-dom0.service
# VM
%systemd_post qubes-meminfo-writer.service

%preun
%systemd_preun qubes-meminfo-writer-dom0.service
%systemd_preun qubes-meminfo-writer.service

%postun
%systemd_postun_with_restart qubes-meminfo-writer-dom0.service
%systemd_postun_with_restart qubes-meminfo-writer.service

%post libs -p /sbin/ldconfig
%postun libs -p /sbin/ldconfig

%clean
rm -rf $RPM_BUILD_ROOT

%files
%defattr(-,root,root,-)
%_udevrulesdir/*-qubes-*.rules
%_tmpfilesdir/xen-devices-qubes.conf
%dir %{_prefix}/lib/qubes
%{_prefix}/lib/qubes/udev-*
%{_sbindir}/meminfo-writer
%{_unitdir}/qubes-meminfo-writer.service
%{_unitdir}/qubes-meminfo-writer-dom0.service
%dir %_includedir/qubes
/etc/xen/scripts/qubes-block

%files -n python%{python3_pkgversion}-qubesimgconverter
%dir %{python3_sitelib}/qubesimgconverter
%{python3_sitelib}/qubesimgconverter/__init__.py
%{python3_sitelib}/qubesimgconverter/imggen.py
%{python3_sitelib}/qubesimgconverter/test.py
%{python3_sitelib}/qubesimgconverter/test_integ.py
%{python3_sitelib}/qubesimgconverter-%{version}-py?.[0-9]*.egg-info
%{python3_sitelib}/qubesimgconverter/__pycache__

%files libs
%{_libdir}/libqubes-rpc-filecopy.so.2
%{_libdir}/libqubes-pure.so.0

%files devel
%defattr(-,root,root,-)
%_includedir/libqubes-rpc-filecopy.h
%dir %_includedir/qubes
%_includedir/qubes/pure.h
%{_libdir}/libqubes-rpc-filecopy.so
%{_libdir}/libqubes-pure.so

%changelog
* Wed Nov 06 2024 Qubes OS Team <qubes-devel@googlegroups.com>
- For complete changelog see: https://github.com/QubesOS/qubes-linux-utils.git

* Wed Nov 06 2024 Marek Marczykowski-Górecki <marmarek@invisiblethingslab.com> - 7e2d762
- version 4.3.5

* Tue Oct 08 2024 Rusty Bird <rustybird@net-c.com> - 8cdd664
- qubes-block: disable direct I/O for now

* Sat Aug 24 2024 Marek Marczykowski-Górecki <marmarek@invisiblethingslab.com> - ac0bfb0
- version 4.3.4

* Wed Aug 21 2024 Marek Marczykowski-Górecki <marmarek@invisiblethingslab.com> - c67af4e
- tests: assertEquals -> assertEqual

* Fri Jul 19 2024 Ali Mirjamali <ali@mirjamali.com> - aa87982
- Add qubes version to boot menu

* Fri Jul 05 2024 Marek Marczykowski-Górecki <marmarek@invisiblethingslab.com> - c9b25d6
- version 4.3.3

* Sat Jun 22 2024 Marek Marczykowski-Górecki <marmarek@invisiblethingslab.com> - 973fe96
- Do not redefine compiler flags that are up to build env to define

* Mon Jun 17 2024 Marek Marczykowski-Górecki <marmarek@invisiblethingslab.com> - c231fe5
- version 4.3.2

* Mon Jun 17 2024 Marek Marczykowski-Górecki <marmarek@invisiblethingslab.com> - ff76ff4
- debian: bump required versions for libs

* Mon Jun 17 2024 Marek Marczykowski-Górecki <marmarek@invisiblethingslab.com> - c7dbb73
- version 4.3.1

* Sat Jun 15 2024 Demi Marie Obenour <demi@invisiblethingslab.com> - 044c4d4
- Don't allow trailing slashes in paths being unpacked

* Sat Jun 15 2024 Demi Marie Obenour <demi@invisiblethingslab.com> - aa0b85e
- Allow disabling symbolic link checking

* Sat Jun 15 2024 Demi Marie Obenour <demi@invisiblethingslab.com> - af7ae9b
- Add flag to allow non-canonical symbolic links

* Sat Jun 15 2024 Demi Marie Obenour <demi@invisiblethingslab.com> - 17c27ac
- Use for loop instead of do-while

* Sat Jun 15 2024 Demi Marie Obenour <demi@invisiblethingslab.com> - 5dcc596
- Improve symlink tests

* Sat Jun 15 2024 Demi Marie Obenour <demi@invisiblethingslab.com> - aa2466c
- Allow disabling character set filtering

* Sat Jun 15 2024 Demi Marie Obenour <demi@invisiblethingslab.com> - 34172df
- Better error message for forbidden symbolic links

* Sat Jun 15 2024 Marek Marczykowski-Górecki <marmarek@invisiblethingslab.com> - 1a659f8
- version 4.3.0

* Sat Jun 15 2024 Marek Marczykowski-Górecki <marmarek@invisiblethingslab.com> - e8669db
- ci: update tags

* Mon May 20 2024 Demi Marie Obenour <demi@invisiblethingslab.com> - 075dfe4
- Do not use fchmodat() because it follows symlinks

* Mon May 20 2024 Demi Marie Obenour <demi@invisiblethingslab.com> - edece29
- Do not use path containing "/" in linkat() or stat()

* Mon May 20 2024 Demi Marie Obenour <demi@invisiblethingslab.com> - 2a0da19
- Avoid redundantly validating symbolic link names

* Mon May 20 2024 Demi Marie Obenour <demi@invisiblethingslab.com> - 188b608
- Fix -Wmissing-declarations and -Wmissing-prototypes warnings

* Mon May 20 2024 Demi Marie Obenour <demi@invisiblethingslab.com> - 0070e55
- Avoid casting away const when not needed

* Mon May 20 2024 Demi Marie Obenour <demi@invisiblethingslab.com> - cb5c376
- Document the pretty-printer in the code generator

* Mon May 20 2024 Demi Marie Obenour <demi@invisiblethingslab.com> - a656698
- Move path validation tests before charset tests

* Mon May 20 2024 Demi Marie Obenour <demi@invisiblethingslab.com> - 9f78bc4
- Test that symbolic links can end in '/'

* Mon May 20 2024 Demi Marie Obenour <demi@invisiblethingslab.com> - 34c92b5
- Allow symlinks ending in ".."

* Mon May 20 2024 Demi Marie Obenour <demi@invisiblethingslab.com> - f0f23af
- Document algorithm used to sanitize paths

* Wed May 08 2024 Piotr Bartman <prbartman@invisiblethingslab.com> - 3ad3bb2
- q-dev: add data to qubesdb needed by new API

* Thu May 02 2024 Marek Marczykowski-Górecki <marmarek@invisiblethingslab.com> - 5582539
- version 4.2.16

* Tue Jan 09 2024 Demi Marie Obenour <demi@invisiblethingslab.com> - 4e9e357
- Math and currency symbols are safe for display

* Thu Jan 04 2024 Marek Marczykowski-Górecki <marmarek@invisiblethingslab.com> - ba9b37e
- Switch to sequoia for codecov signature check

* Thu Jan 04 2024 Marek Marczykowski-Górecki <marmarek@invisiblethingslab.com> - 5dc579d
- Fix imgconverter tests

* Wed Jan 03 2024 Marek Marczykowski-Górecki <marmarek@invisiblethingslab.com> - 5961672
- ci: collect test coverage from qrexec-lib too

* Mon Dec 04 2023 Marek Marczykowski-Górecki <marmarek@invisiblethingslab.com> - 5df5616
- version 4.2.15

* Sun Dec 03 2023 Rusty Bird <rustybird@net-c.com> - 13a0ede
- qrexec-lib/pack: sanitize straight quotes in remote filenames

* Sat Dec 02 2023 Rusty Bird <rustybird@net-c.com> - 71f5b04
- qrexec-lib/pack: don't use curly quotes in error messages

* Mon Nov 13 2023 Demi Marie Obenour <demi@invisiblethingslab.com> - b1e335a
- Avoid writing junk into Xenstore

* Sun Nov 05 2023 Marek Marczykowski-Górecki <marmarek@invisiblethingslab.com> - 24cdce9
- rpm: adjust dependencies for openSUSE

* Sat Nov 04 2023 Marek Marczykowski-Górecki <marmarek@invisiblethingslab.com> - ad0b68b
- genfs: fix build/link flags

* Sat Nov 04 2023 Marek Marczykowski-Górecki <marmarek@invisiblethingslab.com> - bc62e92
- rpm: fix missing directory ownership

* Wed Sep 27 2023 Marek Marczykowski-Górecki <marmarek@invisiblethingslab.com> - 96698e2
- version 4.2.14

* Wed Sep 27 2023 Demi Marie Obenour <demi@invisiblethingslab.com> - f89a3b8
- Block Zalgo text

* Sun Sep 24 2023 Rusty Bird <rustybird@net-c.com> - 3ee5516
- qrexec-lib/unpack: fail on EOF before end of transfer marker

* Sun Sep 17 2023 Demi Marie Obenour <demi@invisiblethingslab.com> - 3925e82
- Expose code point allowlist checking API

* Sun Sep 10 2023 Marek Marczykowski-Górecki <marmarek@invisiblethingslab.com> - 6c4902e
- version 4.2.13

* Sun Aug 20 2023 Marek Marczykowski-Górecki <marmarek@invisiblethingslab.com> - 6fe6fac
- version 4.2.12

* Wed Aug 16 2023 Demi Marie Obenour <demi@invisiblethingslab.com> - 711e416
- Drop unmaintained asynctest library

* Mon Aug 14 2023 Demi Marie Obenour <demi@invisiblethingslab.com> - 6f4f1ab
- Make qubes_pure_string_safe_for_display() usable

